import proxml.*;

XMLInOut inOut = new XMLInOut(this); 
PFont LS14;
PFont LS20;
PFont GS12;
PFont LS10;

boolean gLoaded = false;

class DataPoint {
  int itemTime;
  int itemDay;

  DataPoint(int it, int id) {
    itemTime = it;
    itemDay = id;
  }
}

int datei = 0;
int timei = 1;
int classi = 2;

int r1 = 253;
int g1 = 110;
int b1 = 164;
int r2 = 117;
int g2 = 1;
int b2 = 174;
int alpha1 = 100;

int dewey1 = 641;
int dewey2 = 741;

// DRAWING GUIDES 
int graphLeft = 60; 
int graphTop = 90;
int graphW = 834;
int graphH = 600;
int lineWidth = 12;
int offset = 27;
int graphLeft1 = graphLeft+lineWidth-1;

DataPoint[] data641 = new DataPoint[0];
DataPoint[] data741 = new DataPoint[0];

void setup() {
  size(954,735);

  LS20 = loadFont("LucidaSans-20.vlw");
  LS14 = loadFont("LucidaSans-14.vlw");
  GS12 = loadFont("GillSans-12.vlw");
  LS10 = loadFont("LucidaSans-10.vlw");
  println("loading");
  inOut.loadElement("checkOut_Jan08.xml");
}

void xmlEvent(XMLElement element) {
  println("begin parsing");
  XMLElement[] days;
  XMLElement[] hours;
  XMLElement[] transactions;
  XMLElement d,h,t,v1;
  int i,j,k, numHours;
  if(element.hasChildren()) {
    days = element.getChildren();
    for(i=0; i<days.length; i++) {
      println("");
      print("day " + i );
      hours = days[i].getChildren();
      for(j=0; j< hours.length; j++) {
        print(" :: "+j);
        transactions = hours[j].getChildren();
        for(k=0; k<transactions.length; k++) {
          t = transactions[k];
          if(t.hasChildren()) {                     
            int deweyClassNumber = int(t.getChild(classi).firstChild().getText());  // get the dewey number and convert to a int            
            switch(deweyClassNumber) {
            case 641://dewey1://398 
              String cot = t.getChild(timei).firstChild().getText();
              String[] cot_split = split(cot, ":");
              int checkOutMin = int(cot_split[1]);
              int checkOutHor = int(cot_split[0]);
              int checkOutTime = checkOutHor*60+checkOutMin;
              String cod = t.getChild(datei).firstChild().getText();
              String[] cod_split = split(cod, "-");
              int checkOutDay = int(cod_split[2]);
              DataPoint dp = new DataPoint(checkOutTime, checkOutDay);                                 
              data641 = (DataPoint[])append(data641, dp);
              break;

            case 741://dewey2://796:
              String cot1 = t.getChild(timei).firstChild().getText();
              String[] cot1_split = split(cot1, ":");
              int checkOutMin1 = int(cot1_split[1]);
              int checkOutHor1 = int(cot1_split[0]);
              int checkOutTime1 = checkOutHor1*60+checkOutMin1;
              String cod1 = t.getChild(datei).firstChild().getText();
              String[] cod_split1 = split(cod1, "-");
              int checkOutDay1 = int(cod_split1[2]);
              DataPoint dp1 = new DataPoint(checkOutTime1, checkOutDay1);                                 
              data741 = (DataPoint[])append(data741, dp1);
              }

            }
          }
        }
      }
    }
    println("FINISHED PARSING");
  gLoaded = true;
  }
  
  void drawGrid() {
  
    // some text
    textFont(LS14);
    fill(#E66101);//4,99,128);
    textAlign(LEFT);
    String food = "food + drink ";//folklore
    text(food,graphLeft, 58);
    float fw = textWidth(food);
    char v = 'v';
    textAlign(RIGHT);
    text("["+dewey1+"] ",graphLeft+fw,44);//398
    textAlign(LEFT);
    fill(26);
    text(v,graphLeft+fw,58);
    fill(#5E3C99);//192,48, 0);
    float vw = textWidth(v);
    text(" drawing + drawings ", graphLeft+fw+vw, 58); //athletic + outdoor sports + games
    text(" ["+dewey2+"]",graphLeft+fw+vw,44);                //796
    textAlign(RIGHT);
    fill(126);
    text("time items checked out / day",width-60,44);
    text("month of january",width-60,58);
    fill(226);
    textFont(LS20);
    textAlign(RIGHT);
    text("Seattle Central Library", width-60, height-2);
    
    // draw day # and vertical lines
    
    for(int i=6; i<32;i+=7) {
        stroke(126);
        fill(226);
        rect(graphLeft+((i-1)*offset)+1,graphTop+graphH+2,offset-3,12);
    }
    
    for(int i = 1; i < 32;i++) {
        fill(126);
        textFont(GS12);
        textAlign(CENTER);
        text(i,graphLeft+(i*offset)-lineWidth-1,graphTop+graphH+13);
      }
      
    
    for (int i=1; i<31; i+=2) {
      noStroke();
      fill(226);
      rect(graphLeft+(i*offset),graphTop, offset, graphH);
    }
    
    // draw horiz lines
    for(int i = 0; i<11; i++) {
      stroke(126);
      line(graphLeft-3,graphTop+(i*60), graphLeft+graphW+3, graphTop+(i*60));
      if (i<10) {
      fill(126);
      textAlign(RIGHT);
      text((i+10) +":00", graphLeft-6, graphTop+(i*60)+12);
      textAlign(LEFT);
      text((i+10) +":59", graphLeft+graphW+5, graphTop+(i*60)+59);
      }
    }
    
   /* for (int i=1; i<11; i+=2) {
      noStroke();
      fill(226);
      rect(graphLeft, graphTop+(i*60), graphW, 60);
    }*/
    
    for(int i=1; i<32;i+=7) {
      textFont(LS10);
      fill(126);
      textAlign(CENTER);
      text("Tu", graphLeft+(i*offset)-lineWidth-1,graphTop-3);
    }
    for(int i=2; i<32;i+=7) {
      text("We", graphLeft+(i*offset)-lineWidth-1,graphTop-3);
    }
    for(int i=3; i<32;i+=7) {
      text("Th", graphLeft+(i*offset)-lineWidth-1,graphTop-3);
    }
    for(int i=4; i<32;i+=7) {
      text("Fr", graphLeft+(i*offset)-lineWidth-1,graphTop-3);
    }
    for(int i=5; i<32;i+=7) {
      text("Sa", graphLeft+(i*offset)-lineWidth-1,graphTop-3);
    }
    for(int i=7; i<32;i+=7) {
      text("Mo", graphLeft+(i*offset)-lineWidth-1,graphTop-3);
    }
    for(int i=6; i<32;i+=7) {
      stroke(126);
      fill(226);
      rect(graphLeft+((i-1)*offset)+1,graphTop-14,offset-3,12);
      fill(126);
      text("Su", graphLeft+(i*offset)-lineWidth-1,graphTop-3);
    }
    
noLoop();
  }

void draw() {
  background(255);
  if(!gLoaded) {
    textFont(LS20);
    text("loading and parsing xml data...", 53, 39);
  } else {
      drawGrid();
      drawData();
  }
}
  
void drawData () {
  smooth();
    
    // draw the damn data
    for(int i = 0; i < data641.length; i++) {
      DataPoint dp = data641[i];
        if(dp.itemTime >= 600 && dp.itemTime <= 1200) {
          stroke(#E66101);//#CA0020,alpha1);
          line(((dp.itemDay-1)*offset)+graphLeft+3, dp.itemTime-600+graphTop,((dp.itemDay-1)*offset)+graphLeft+lineWidth,dp.itemTime-600+graphTop);
        }  
    }
    
      for(int i = 0; i < data741.length; i++) {
      DataPoint dp = data741[i];
        if(dp.itemTime >= 600 && dp.itemTime <= 1200) {
          stroke(#5E3C99);//0571B0,alpha1);
          line(((dp.itemDay-1)*offset)+graphLeft1+3, dp.itemTime-600+graphTop,((dp.itemDay-1)*offset)+graphLeft1+lineWidth,dp.itemTime-600+graphTop);
        }  
    }
    
}


